%
% Plot the [a,b] interval over the iterations for different lambda
% values (min, mid, max))
%


% Clear workspace and load the functions and interval
clear
addpath('..');
GivenEnv;

% * lambda_min: 0.0001
% * lambda_max: 0.1
% * N: 3 lambda values

N = 3;
lambda_min = 0.0001;
lambda_max = 0.1;
lambda = linspace(lambda_min, lambda_max, N);
k = zeros(1, N); % preallocate k


%
% * Call the golden_sector method for each lambda value for each function and
%   keep the number of iterations needed.
% * Plot the [a,b] interval over iterations for each lambda for each function 
%

for i = 1:length(funs)
    figure;
    for j = 1:N
        [a, b, k(j)] = golden_section(funs{i}, a_0, b_0, lambda(j));
        subplot(length(funs), 1, j)
        plot(1:length(a), a, 'ob')
        hold on
        plot(1:length(b), b, '*r')
        if j == 1
            title(titles(i), 'Interpreter', 'latex')
        end
        xlabel("Iterations @lambda=" + lambda(j))
        ylabel('[a_k, b_k]')
    end
end

  